#if !defined(AFX_SETUPDIALOG_H__D1422FCB_C860_4639_9469_B8A1A9A75481__INCLUDED_)
#define AFX_SETUPDIALOG_H__D1422FCB_C860_4639_9469_B8A1A9A75481__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SetupDialog.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CSetupDialog dialog

#include "FileManagerWindow.h"

class CSetupDialog : public CDialog
{
// Construction
public:
	CSetupDialog(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CSetupDialog)
	enum { IDD = IDD_SETUP_DIALOG };
	CProgressCtrl	m_progressExport;
	CStatic			m_staticExportPath;
	CStatic			m_staticRecordPath;
	CStatic			m_staticSerialNumber;
	CButton			m_btnExport;
	CButton			m_btnSync;
	CButton			m_btnSnapshot;
	CButton			m_btnDefault;
	CButton			m_btnApply;
	CButton			m_btnProperty04;
	CButton			m_btnProperty03;
	CButton			m_btnProperty02;
	CButton			m_btnProperty01;
	CComboBox		m_comboGOP04;
	CComboBox		m_comboGOP03;
	CComboBox		m_comboGOP02;
	CComboBox		m_comboGOP01;
	CComboBox		m_comboQuality04;
	CComboBox		m_comboQuality03;
	CComboBox		m_comboQuality02;
	CComboBox		m_comboQuality01;
	CComboBox		m_comboBitRate04;
	CComboBox		m_comboBitRate03;
	CComboBox		m_comboBitRate02;
	CComboBox		m_comboBitRate01;
	CComboBox		m_comboRecordMode04;
	CComboBox		m_comboRecordMode03;
	CComboBox		m_comboRecordMode02;
	CComboBox		m_comboRecordMode01;
	CComboBox		m_comboFrameRate04;
	CComboBox		m_comboFrameRate03;
	CComboBox		m_comboFrameRate02;
	CComboBox		m_comboFrameRate01;
	CComboBox		m_comboDeinterlace04;
	CComboBox		m_comboDeinterlace03;
	CComboBox		m_comboDeinterlace02;
	CComboBox		m_comboDeinterlace01;
	CComboBox		m_comboResolution04;
	CComboBox		m_comboResolution03;
	CComboBox		m_comboResolution02;
	CComboBox		m_comboResolution01;
	CEdit			m_editChannel01;
	CEdit			m_editChannel02;
	CEdit			m_editChannel03;
	CEdit			m_editChannel04;
	CComboBox		m_comboStandard;
	CEdit			m_editProperty;
	CEdit			m_editGOP;
	CEdit			m_editQuality;
	CEdit			m_editBitRate;
	CEdit			m_editRecordMode;
	CEdit			m_editFrameRate;
	CEdit			m_editDeinterlace;
	CEdit			m_editResolution;
	CEdit			m_editChannel;
	CEdit			m_editStandard;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSetupDialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CSetupDialog)
	virtual void OnOK();
	virtual void OnCancel();
	virtual BOOL OnInitDialog();
	afx_msg void OnApply();
	afx_msg void OnDefault();
	afx_msg void OnSelChangeComboRecordModeCh01();
	afx_msg void OnSelChangeComboRecordModeCh02();
	afx_msg void OnSelChangeComboRecordModeCh03();
	afx_msg void OnSelChangeComboRecordModeCh04();
	afx_msg void OnSelChangeComboStandard();
	afx_msg void OnDestroy();
	afx_msg void OnSync();
	afx_msg void OnExport();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnSnapshot();
	afx_msg void OnSelChangeComboResolutionCh01();
	afx_msg void OnSelChangeComboResolutionCh02();
	afx_msg void OnSelChangeComboResolutionCh03();
	afx_msg void OnSelChangeComboResolutionCh04();
	afx_msg void OnButtonPropertyCh01();
	afx_msg void OnButtonPropertyCh02();
	afx_msg void OnButtonPropertyCh03();
	afx_msg void OnButtonPropertyCh04();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:

	BOOL				OnSelChangeTabDisplay_SC210Dlg( ULONG nDisplayModeNumber );

	BOOL				GetStandardParameters( ULONG * pStandard );

	BOOL				GetResolutionParameters( ULONG * pFrameWidth, ULONG * pFrameHeight );

	BOOL				GetDeinterlaceParameters( ULONG * pDeinterlace );

	BOOL				GetFrameRateParameters( double * fFrameRate );

	BOOL				GetRecordModeParameters( ULONG * pRecordMode );

	BOOL				GetBitRateParameters( ULONG * pBitRate );

	BOOL				GetQualityParameters( ULONG * pQuality );

	BOOL				GetGOPParameters( ULONG * pGOP );

	BOOL				GetRecordPathParameters( CHAR * pszRecordPath );

	BOOL				GetCaptureCardOutputResolution( ULONG * pFrameWidth, ULONG * pFrameHeight );

	ULONG				m_nLargestAvailableDiskNumber;

	CFileManagerWindow	m_oFileManagerWindow;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SETUPDIALOG_H__D1422FCB_C860_4639_9469_B8A1A9A75481__INCLUDED_)
